/* Experiment med timers */
// --------------------------------------------------
// Globala variabler
let bagElem;                    // Element för säcken
let bagStep = 5;                // Antal pixlar säcken ska flyttas i varje steg.
let bagTime = 20;               // Tid i ms för säckens förflyttning
let bagTimerId = null;          // Timer för förflyttning av säcken

let presentElem;                // Element för julklapp
let presentStep = 5;            // Antal pixlar julklappen ska flyttas i varje steg.
let presentTime = 20;           // Tid i ms för julklappens förflyttning
let presentTimerId = null;      // Timer för förflyttning av julklappen

let newPresentTime = 2000;      // Tid till en ny julklapp
let newPresentTimerId = null;   // Timer för ny julklapp

let counter;                    // Räknare för antal fångade julklappar
let counterElem;                // Element för utskrift av räknaren
// --------------------------------------------------
// Initiering då webbsidan laddats in
function init() {
    bagElem = document.querySelector("#bag");
    presentElem = document.querySelector("#present");
    counterElem = document.querySelector("#counter");
    document.querySelector("#startBtn").addEventListener("click", startGame);
    document.querySelector("#stopBtn").addEventListener("click", stopGame);
    document.addEventListener("keydown", checkKey);
} // Slut init
window.addEventListener("load", init);
// --------------------------------------------------
// Initiering av variabler start av timers
function startGame() {
    document.activeElement.blur(); // Fix för Firefox
    stopGame();
    counter = 0;
    counterElem.innerText = 0;
    bagStep = Math.abs(bagStep); // Börja med ett positivt värde
    bagElem.style.left = "10px";
    bagTimerId = setInterval(moveBag, bagTime);
    newPresentTimerId = setTimeout(newPresent, newPresentTime);
} // Slut startGame
// --------------------------------------------------
// Stoppa timers
function stopGame() {
    if (bagTimerId) clearInterval(bagTimerId);
    if (presentTimerId) clearInterval(presentTimerId);
    if (newPresentTimerId) clearTimeout(newPresentTimerId);
} // Slut stopGame
// --------------------------------------------------
// Kontrollera tangenter, byt riktning på säcken
function checkKey(e) {
    switch (e.code) {
        case "Space":
            bagStep = -bagStep; // Byt riktning
            break;
    }
} // Slut checkKey
// --------------------------------------------------
// Flytta säcken i sidled
function moveBag() {
    let x = parseInt(bagElem.style.left) + bagStep;
    bagElem.style.left = x + "px";
    if (presentTimerId && notCatched) {
        if (elementsOverlap(bagElem, presentElem)) { // "Krocktest"
            presentElem.src = "img/zap.png";
            notCatched = false;
            counter++;
            counterElem.innerText = counter;
        }
    }
} // Slut moveBag
// --------------------------------------------------
// Bestäm position för ny julklapp och starta timer för förflyttning
function newPresent() {
    let x = Math.floor(460 * Math.random() + 80);
    presentElem.style.left = x + "px";
    presentElem.style.top = "0px";
    presentElem.src = "img/present.png";
    presentElem.style.visibility = "visible";
    notCatched = true;
    presentTimerId = setInterval(movePresent, presentTime);
} // Slut newPresent
// --------------------------------------------------
// Flytta julklappen
function movePresent() {
    let y = parseInt(presentElem.style.top) + presentStep;
    presentElem.style.top = y + "px";
    if (y > 340) {
        if (presentTimerId) clearInterval(presentTimerId);
        presentTimerId = null;
        newPresentTimerId = setTimeout(newPresent, newPresentTime);
    }
} // Slut movePresent
// --------------------------------------------------
// Kontrollera om två element överlappar varandra och returna i så fall true, annars false
function elementsOverlap(elem1, elem2) {
    let r1 = elem1.getBoundingClientRect();
    let r2 = elem2.getBoundingClientRect();
    if (r1.right < r2.left || r1.left > r2.right ||
        r1.bottom < r2.top || r1.top > r2.bottom) {
        return false;
    }
    else {
        return true;
    }
} // Slut elementsOverlap
// --------------------------------------------------
