/* Experiment med video */
// --------------------------------------------------
// Globala variabler
let videoMenu;      // Element för videomenyn
let videoElem;      // Element för videon
let videoInfoElem;  // Element för info om videon
let controlForm;    // form-element för kontrollknappar
let bookmarks = []; // Array med bokmärken
// --------------------------------------------------
// Initiering då webbsidan laddats in
function init() {
    videoElem = document.querySelector("#tv video");
    videoElem.loop = true; // Filmen kommer att loopa, tills man stoppar den
    videoInfoElem = document.querySelector("#tv p");
    controlForm = document.querySelector("#control");
    controlForm.videoMenu.addEventListener("change", changeVideo);
    controlForm.playBtn.addEventListener("click", playVideo);
    controlForm.pauseBtn.addEventListener("click", pauseVideo);
    controlForm.bookmarkBtn.addEventListener("click", bookmarkVideo);
    controlForm.bookmarkMenu.addEventListener("change", selectBookmark);
    controlForm.bookmarkMenu.disabled = true;
    let HTMLcode = "";
    for (let i = 0; i < videoTitles.length; i++) {
        HTMLcode += "<option value='" + i + "'>" +
            videoTitles[i] + "</otion>";
        // Index till arrayerna med titel och filnamn sparas i value-attributet
    }
    controlForm.videoMenu.innerHTML += HTMLcode;
} // Slut init
window.addEventListener("load", init);
// --------------------------------------------------
// Visa vido som valts i menyn
function changeVideo() {
    let ix = this.value; // Index till vald film
    videoElem.src = "media/" + videoFiles[ix];
    videoElem.id = ix; // Spara indexet i video-elementet
    //showVideoInfo();
    videoElem.preload = "metadata";
    videoElem.addEventListener("loadedmetadata", showVideoInfo);
    this.selectedIndex = 0;
} // Slut changeVideo
// --------------------------------------------------
// Visa info om filmen
function showVideoInfo() {
    let ix = videoElem.id; // Index till aktuell film
    let d = videoElem.duration.toFixed(2); // Filmens längd
    let t = videoElem.currentTime.toFixed(2); // Aktuell tid
    videoInfoElem.innerText = videoTitles[ix];
    if (!isNaN(d)) videoInfoElem.innerText += " - " + t + "/" + d + " sek.";
} // Slut showVideoInfo
// --------------------------------------------------
// Starta uppspelning av videon
function playVideo() {
    videoElem.play();
} // Slut playVideo
// --------------------------------------------------
// Stoppa uppseplning av videon
function pauseVideo() {
    videoElem.pause();
    showVideoInfo();
} // Slut pauseVideo
// --------------------------------------------------
// Lägg in nytt bokmärke med vidourl och tidsposition
function bookmarkVideo() {
    pauseVideo();
    let ix = videoElem.id;
    let t = videoElem.currentTime;
    bookmarks.push(ix + "&" + t);
    controlForm.bookmarkMenu.innerHTML +=
        "<option>" + videoTitles[ix] + "-" + t.toFixed(2) + "</option>";
    controlForm.bookmarkMenu.disabled = false;
} // Slut bookmarkVideo
// --------------------------------------------------
// Visa film och position i video för valt bokmärke
function selectBookmark() {
    let b = this.selectedIndex - 1;
    let bookmark = bookmarks[b].split("&");
    let ix = bookmark[0];
    videoElem.id = ix;
    videoElem.src = "media/" + videoFiles[ix];
    videoElem.currentTime = Number(bookmark[1]);
    //showVideoInfo();
    videoElem.preload = "metadata";
    videoElem.addEventListener("loadedmetadata", showVideoInfo);
    this.selectedIndex = 0;
} // Slut selectBookmark
// --------------------------------------------------
